var _this14 = this;
function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }
function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }
function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { _defineProperty(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
function _defineProperty(obj, key, value) { key = _toPropertyKey(key); if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
function _toPropertyKey(arg) { var key = _toPrimitive(arg, "string"); return typeof key === "symbol" ? key : String(key); }
function _toPrimitive(input, hint) { if (typeof input !== "object" || input === null) return input; var prim = input[Symbol.toPrimitive]; if (prim !== undefined) { var res = prim.call(input, hint || "default"); if (typeof res !== "object") return res; throw new TypeError("@@toPrimitive must return a primitive value."); } return (hint === "string" ? String : Number)(input); }
import { createPopper } from "@popperjs/core";

/*
 * Choice JS
*/

class Builder {
  //Constructor
  constructor(target, userOptions) {
    /**
     * Block observer
    */
    _defineProperty(this, "visibilityObserver", new IntersectionObserver((entries, self) => {
      //For each of the entries
      entries.forEach(entry => {
        //If the image is intersecting
        if (!entry.isIntersecting) {
          //Hide
          this.destroyDropdown();
        }
      });
    }, {}));
    this.target = target;
    this.dropdown = false;
    //Build our default options
    this.options = _objectSpread(_objectSpread({}, this.buildDefaultOptions(userOptions)), userOptions);
    this.closeListener = this.closeListener.bind(this);
  }

  /**
   * Create a new choice dropdown
   *
   * @return {Promise}
  */
  create() {
    var _this = this;
    return _asyncToGenerator(function* () {
      //Build the select box
      _this.choice = yield _this.buildChoice();
      //Global bindings
      yield _this.bindActiveListener();
      _this.bindEventListener();
      //Dispatch event to load it
      _this.target.dispatchEvent(new Event('change'));
      //Return
      return _this.choice;
    })();
  }

  /**
   * Build the default options
   *
   * @param {Object} userOptions The user options for any overwrites
   * @return {Object} An object of options
  */
  buildDefaultOptions(userOptions) {
    var options = {
      width: 'inherit',
      height: 'inherit',
      placeholder: this.target.hasAttribute('placeholder') ? this.target.getAttribute('placeholder') : false,
      class: '',
      closeOnSelect: false,
      event: 'change',
      copyAttributes: true,
      bindTo: 'parent'
    };
    //Return
    return options;
  }

  /**
   * Configure options for the choice
   *
   * @return {Promise}
  */
  configureOptions(choice) {
    var _this2 = this;
    return _asyncToGenerator(function* () {
      //Width and height
      choice.style.width = _this2.options.width == 'inherit' ? _this2.target.offsetWidth + 'px' : _this2.options.width, choice.style.minHeight = _this2.options.height == 'inherit' ? _this2.target.offsetHeight + 'px' : _this2.options.height;

      //Class
      if (_this2.options.class != '') choice.classList.add(_this2.options.class);

      //Placeholder
      if (_this2.options.placeholder) choice.querySelector('.choicejs-select').innerHTML = _this2.options.placeholder;

      //Return
      return;
    })();
  }

  /**
   * Bind active click
   *
   * @param {HTMLElement} choice - The choice we're binding
   * @return {Promise}
  */
  bindActiveListener() {
    var _this3 = this;
    return _asyncToGenerator(function* () {
      //Listeners
      _this3.choice.addEventListener('click', /*#__PURE__*/_asyncToGenerator(function* () {
        //If we're already open, do nothing
        if (_this3.choice.classList.contains('active')) return;
        //Create the dropdown
        yield _this3.buildDropdown();
        //Observe for visibility
        _this3.visibilityObserver.observe(_this3.choice);
        //Bind close listener
        document.addEventListener('click', _this3.closeListener);
        //Add the active class
        _this3.choice.classList.add('active');
        //If the user has provided a search url and the `data-choice-search-preload` attribute, run a keyup to pre-load some data
        if (_this3.target.hasAttribute('data-choice-search-url') && _this3.target.hasAttribute('data-choice-search-preload')) {
          _this3.dropdown.querySelector('.choicejs-search').dispatchEvent(new Event('keyup'));
        }
      }));

      //Return
      return;
    })();
  }

  /**
   * Bind Event Listener
   *
   * @param {HTMLElement} choice - The choice we're binding
   * @return {Promise}
  */
  bindEventListener() {
    var _this4 = this;
    return _asyncToGenerator(function* () {
      //When an event is fired on the target, change our dropdowns
      _this4.target.addEventListener(_this4.options.event, /*#__PURE__*/_asyncToGenerator(function* () {
        //Rebuild the options and pills on the target change
        var multiple = _this4.target.hasAttribute('multiple') && ['true', 'multiple'].includes(_this4.target.getAttribute('multiple')),
          choice_select = _this4.choice.querySelector('.choicejs-select');

        //Reset the select placeholder
        choice_select.innerHTML = _this4.options.placeholder ? _this4.options.placeholder : '';

        //If the dropdown is currently open reset all options
        if (_this4.dropdown) {
          for (var option of _this4.dropdown.querySelectorAll("ul li")) {
            option.removeAttribute('selected');
          }
        }

        //Are we working with multiple?
        if (!multiple) {
          //Get the value of the selected select option and make sure there is one
          var selected_value = _this4.target.value;
          if (selected_value != '') {
            //Set the visual HTML of the choice select
            choice_select.innerHTML = _this4.target.querySelector('option:checked').innerHTML;
            //If theres a dropdown open, enable the option
            if (_this4.dropdown) {
              _this4.dropdown.querySelector("ul li[value=\"".concat(selected_value, "\"]")).setAttribute('selected', true);
            }
          }
        } else {
          //Start building pills
          var pills = [];
          //Get all of the selected options and check we have some
          var selected_options = _this4.target.querySelectorAll('option:checked');
          if (selected_options.length > 0) {
            //Reset the choice select innerHTML
            choice_select.innerHTML = '';
            //Loop over all of the selected options
            for (var _option of selected_options) {
              //Add a pillbox
              pills.push(_this4.buildOptionPill(_option));
              //If there is a dropdown open, enable the option
              if (_this4.dropdown) {
                _this4.dropdown.querySelector("ul li[value=\"".concat(_option.value, "\"]")).setAttribute('selected', true);
              }
            }
          }
          yield Promise.all(pills);
        }
      }));
    })();
  }

  /**
   * Bind option select
   *
   * @param {HTMLElement} choice - The choice we're binding
   * @return {Promise}
  */
  bindOptionSelect() {
    var _this5 = this;
    return _asyncToGenerator(function* () {
      var _loop = function* _loop(option) {
        //Add the event listener
        option.addEventListener('click', /*#__PURE__*/function () {
          var _ref3 = _asyncToGenerator(function* (e) {
            //Stop Prop
            e.stopPropagation();
            e.stopImmediatePropagation();
            //Add or remove
            if (option.hasAttribute('selected')) {
              //Remove the option
              yield _this5.removeOption(option);
            } else {
              //Add the option
              yield _this5.addOption(option);
            }
            //Close on select?
            if (_this5.options.closeOnSelect) _this5.destroyDropdown();
            //What parent event to trigger?
            if (_this5.options.event !== false) {
              _this5.target.dispatchEvent(new Event(_this5.options.event));
            }
          });
          return function (_x) {
            return _ref3.apply(this, arguments);
          };
        }());
      };
      //Loop and add
      for (var option of _this5.dropdown.querySelectorAll('ul li')) {
        yield* _loop(option);
      }
      //Return
      return;
    })();
  }

  /**
   * Bind dynamic search if the user has provided an endpoint to use
   *
   * @param {HTMLElement} choice - The choice we're binding
   * @return {Promise}
  */
  bindDynamicSearch() {
    var _this6 = this;
    return _asyncToGenerator(function* () {
      //Has the user also asked for multiple? If yes, warn and quit
      var multiple = _this6.target.hasAttribute('multiple') && ['true', 'multiple'].includes(_this6.target.getAttribute('multiple'));
      if (multiple) {
        console.info("Choice JS - Multiple options is not supported with live searching.");
        return;
      }
      //Get the url endpoint if we have one
      if (_this6.target.hasAttribute('data-choice-search-url')) {
        //Get the endpoint we're using
        var endpoint = _this6.target.getAttribute('data-choice-search-url'),
          searchBar = _this6.dropdown.querySelector('.choicejs-search'),
          choiceList = _this6.dropdown.querySelector('ul');
        //Watch for the search change
        var searchTimeout = 0;
        //Remove the bindings to avoid duplicates
        searchBar.addEventListener('keyup', _listener => {
          //Try
          try {
            clearTimeout(searchTimeout);
            //Set timeout
            searchTimeout = setTimeout( /*#__PURE__*/_asyncToGenerator(function* () {
              //Clear the select options and the choice options, replace this a loader
              choiceList.innerHTML = '';
              _this6.target.innerHTML = '';
              //Loading
              choiceList.classList.add('loading');
              //Get the user input, allow empty so the user can check in backend if empty and return default set
              var userInput = searchBar.value;
              //Build our params
              var url = new URL(endpoint);
              url.search = new URLSearchParams({
                choicesearch: userInput
              }).toString();
              //Run the search
              var response = yield fetch(url);
              var result = yield response.json();
              //Remove the loader
              choiceList.classList.remove('loading');
              //Add options
              for (var option of result) {
                //Create a new item
                var choiceItem = document.createElement('li'),
                  selectItem = document.createElement('option');
                //Set the visible value
                choiceItem.innerHTML = option.label;
                selectItem.innerHTML = option.label;
                //Set the actual value
                choiceItem.setAttribute('value', option.value);
                selectItem.value = option.value;
                //Append it to our select
                _this6.target.appendChild(selectItem);
              }

              //Build the options
              yield _this6.buildOptionList(choiceList);

              //Bindings
              yield Promise.all([_this6.bindOptionSelect()]);
            }), 1000);
          } catch (e) {
            console.log('ChoiceJS error fetching endpoint', e);
          }
        });
      }
      //Return
      return;
    })();
  }

  /**
   * Bind option filtering. When a user types into the search box
   *
   * @param {HTMLElement} choice - The choice we're binding
   * @return {Promise}
  */
  bindOptionFiltering() {
    var _this7 = this;
    return _asyncToGenerator(function* () {
      //If we have a dynamic url, do not bind to the list
      if (_this7.target.hasAttribute('data-choice-search-url')) return;
      //When the choice search bar changes
      var searchTimeout = 0,
        searchBar = _this7.dropdown.querySelector('.choicejs-search'),
        options = _this7.dropdown.querySelectorAll('ul li');
      //When the postcode is changed, test it
      searchBar.addEventListener('input', () => {
        //Clear the above timeout
        clearTimeout(searchTimeout);
        //Set a new timeout
        searchTimeout = setTimeout(() => {
          //Loop all options
          for (var option of options) {
            if (option.innerHTML.toLowerCase().includes(searchBar.value.toLowerCase())) {
              option.classList.remove('hide');
            } else {
              option.classList.add('hide');
            }
          }
        }, 500);
      });
      //Return
      return;
    })();
  }

  /* ------------------------------------------------------------------------------------------------------------------------------------------------
  |  HTML Builders
  ------------------------------------------------------------------------------------------------------------------------------------------------ */

  /**
   * Build the choice
   *
   * @return {Promise} HTMLElement The new choice
  */
  buildChoice() {
    var _this8 = this;
    return _asyncToGenerator(function* () {
      //Create a new id
      _this8.id = 'choice-' + Math.random().toString(36).substr(2, 4);

      //Build the new Select HTML element and add it directly after the target
      var wrapper = document.createElement('div'),
        select = document.createElement('div');

      //Set attributes
      wrapper.classList.add('choicejs');
      wrapper.setAttribute('id', _this8.id);
      select.classList.add('choicejs-select');

      //Set the id on the target so we can relate them together
      _this8.target.setAttribute('data-choicejs-id', "#".concat(_this8.id));

      //Copy the select boxes attributes
      if (_this8.options.copyAttributes === true) {
        //Only copy over limited attributes
        wrapper.setAttribute('name', _this8.target.getAttribute('name'));
      }

      //Add the new select element to the wrapper
      wrapper.appendChild(select);

      //Configure the options for it
      yield _this8.configureOptions(wrapper);

      //Deploy the select
      _this8.target.parentNode.insertBefore(wrapper, _this8.target.nextSibling);

      //Return
      return wrapper;
    })();
  }

  /**
   * Build dropdown
   *
   * @returns {Promise}
  */
  buildDropdown() {
    var _this9 = this;
    return _asyncToGenerator(function* () {
      //Build the new dropdown html elements
      var dropdownWrapper = document.createElement('div'),
        dropdown = document.createElement('div'),
        list = document.createElement('ul'),
        searchBox = document.createElement('input');

      //Set attributes
      searchBox.classList.add('choicejs-search');
      searchBox.setAttribute('placeholder', 'Search');
      dropdownWrapper.classList.add('choicejs-dropdown-wrapper');
      dropdownWrapper.setAttribute('data-attached-choicejs-id', _this9.id), dropdown.classList.add('choicejs-dropdown');

      //Build the whole select and return it
      dropdown.appendChild(searchBox);
      dropdown.appendChild(list);
      dropdownWrapper.appendChild(dropdown);

      //Add the dropdown to the class for easy access
      _this9.dropdown = dropdownWrapper;

      //Figure out its positioning and style
      dropdown.style.width = "".concat(_this9.choice.offsetWidth, "px");

      //Build the options
      yield _this9.buildOptionList(list);

      //Where are we attaching the fixed popup?
      switch (_this9.options.bindTo) {
        case 'parent':
          _this9.choice.appendChild(dropdownWrapper);
          break;
        case 'body':
          document.querySelector('body').appendChild(dropdownWrapper);
          break;
      }

      //Tether
      createPopper(_this9.choice, dropdownWrapper, {
        placement: 'bottom',
        strategy: 'fixed',
        modifiers: [{
          name: 'offset',
          options: {
            offset: [0, 10]
          }
        }]
      });

      //Bindings
      yield Promise.all([_this9.bindOptionSelect(), _this9.bindOptionFiltering(), _this9.bindDynamicSearch()]);

      //Return
      return dropdownWrapper;
    })();
  }

  /**
   * Destroy dropdown
   *
   * @returns {Promise}
  */
  destroyDropdown() {
    document.removeEventListener('click', this.closeListener);
    this.dropdown.remove();
    this.visibilityObserver.unobserve(this.choice);
    this.choice.classList.remove('active');
    this.dropdown = false;
  }

  /**
   * Build dropdown
   *
   * @returns {Promise}
  */
  buildOptionList(dropdownList) {
    var _this10 = this;
    return _asyncToGenerator(function* () {
      //Add option function
      var addOption = /*#__PURE__*/function () {
        var _ref5 = _asyncToGenerator(function* (option, wrapper) {
          var item = document.createElement('li');
          item.innerHTML = option.innerHTML;
          //Copy all attributes over from the option
          if (_this10.options.copyAttributes === true) {
            for (var i = 0; i < option.attributes.length; i++) {
              item.setAttribute(option.attributes[i].nodeName, option.attributes[i].nodeValue);
            }
          }
          //Active?
          if (option.selected == true) item.setAttribute('selected', true);
          wrapper.appendChild(item);
        });
        return function addOption(_x2, _x3) {
          return _ref5.apply(this, arguments);
        };
      }();

      //Are we working with optgroups?
      var optgroups = _this10.target.querySelectorAll('optgroup');
      if (optgroups.length > 0) {
        for (var optgroup of optgroups) {
          var group = document.createElement('div');
          group.classList.add('optgroup');
          group.setAttribute('label', optgroup.getAttribute('label'));
          //Add the options to the opt group
          for (var option of optgroup.querySelectorAll('option')) {
            if (option.value != '' && option.value != undefined) addOption(option, group);
          }
          //Add the group to the list
          dropdownList.appendChild(group);
        }
      } else {
        //Loop the targets options and build our list
        for (var _option2 of _this10.target.querySelectorAll('option')) {
          if (_option2.value != '' && _option2.value != undefined) addOption(_option2, dropdownList);
        }
      }
    })();
  }

  /**
   * Build option pill
   *
   * @param {Node} option - The option selected
   * @param {Node} select - The select we're appending to
   * @returns {Promise}
  */
  buildOptionPill(option) {
    var _this11 = this;
    return _asyncToGenerator(function* () {
      //Create the pillbox
      var wrapper = document.createElement('div'),
        close = document.createElement('span'),
        value = option.value;
      //Attributes
      wrapper.classList.add('choicejs-pill');
      wrapper.setAttribute('value', value);
      wrapper.innerHTML = option.innerHTML;
      //Build it
      wrapper.appendChild(close);
      _this11.choice.querySelector('.choicejs-select').appendChild(wrapper);
      //Add the remove event listener
      close.addEventListener('click', /*#__PURE__*/function () {
        var _ref6 = _asyncToGenerator(function* (e) {
          //Run remove btn
          yield _this11.removeOption(option);
          //What parent event to trigger?
          if (_this11.options.event !== false) {
            _this11.target.dispatchEvent(new Event(_this11.options.event));
          }
        });
        return function (_x4) {
          return _ref6.apply(this, arguments);
        };
      }());
      //Return
      return;
    })();
  }

  /* ------------------------------------------------------------------------------------------------------------------------------------------------
  |  Misc Functions
  ------------------------------------------------------------------------------------------------------------------------------------------------ */

  /**
   * Add option
   *
   * @param {HTMLElement} option - The option we're selecting
   * @returns {Promise}
  */
  addOption(option) {
    var _this12 = this;
    return _asyncToGenerator(function* () {
      //Get elems
      var value = option.getAttribute('value'),
        multiple = _this12.target.hasAttribute('multiple') && ['true', 'multiple'].includes(_this12.target.getAttribute('multiple'));
      //Mark the option as selected
      _this12.target.querySelector("option[value=\"".concat(value, "\"]")).selected = true;
      //If its not multiple, set the value of the parent select box
      if (!multiple) _this12.target.value = value;
    })();
  }

  /**
   * Remove option
   *
   * @param {HTMLElement} option - The option we're selecting
   * @returns {Promise}
  */
  removeOption(option) {
    var _this13 = this;
    return _asyncToGenerator(function* () {
      //Get elems
      var value = option.value,
        multiple = _this13.target.hasAttribute('multiple') && ['true', 'multiple'].includes(_this13.target.getAttribute('multiple'));
      //Remove the hidden option
      _this13.target.querySelector("option[value=\"".concat(value, "\"]")).selected = false;
      _this13.target.querySelector("option[value=\"".concat(value, "\"]")).removeAttribute('selected');
      //Single or multiple select?
      if (multiple) {
        //If there is still options selected, return now, don't reset the value and index of the select
        if (_this13.target.querySelectorAll("option:checked").length > 0) return;
      }
      //Reset
      _this13.target.value = '';
      _this13.target.selectedIndex = -1;
    })();
  }

  /**
   * Close element on click function
   *
  */
  closeListener(event) {
    if (!this.choice.contains(event.target) && !this.dropdown.contains(event.target)) {
      //Destroy the dropdown
      this.destroyDropdown();
    }
  }
}

/**
 * Export the choice function to use
 *
 * @param {NodeElement} target - The target we're adding the choice to
 * @param {Object} options - The options
 * @returns {Promise}  - An instance of choice
 */
export var Choice = /*#__PURE__*/function () {
  var _ref7 = _asyncToGenerator(function* (target, options) {
    //Start a new Choice
    var newBuild = new Builder(target, options);
    //Run the build
    return yield newBuild.create();
  });
  return function Choice(_x5, _x6) {
    return _ref7.apply(this, arguments);
  };
}();

/**
 * Remove the choice by its target
 *
 * @param {NodeElement} target - The target we're removing the choice from
 */
export var DestroyChoice = /*#__PURE__*/function () {
  var _ref8 = _asyncToGenerator(function* (target) {
    //If the target doesnt have the data-choicejs-id attribute, return
    if (!target.hasAttribute('data-choicejs-id')) return false;
    //Remove the choice
    _this14.destroyDropdown();
    target.parentNode.querySelector('.choicejs').remove();
    //Clear and replace the select
    var new_element = target.cloneNode(true);
    //Remove extra stuff added
    new_element.removeAttribute('data-choicejs-id');
    //Replace it
    target.parentNode.replaceChild(new_element, target);
    //Resolve
    return true;
  });
  return function DestroyChoice(_x7) {
    return _ref8.apply(this, arguments);
  };
}();